#!/usr/bin/python2.7

#############################################################################
# Copyright (C) Labomedia May 2012
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software Foundation,
#  Inc., 51 Franproplin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
#############################################################################

from twisted.internet import reactor
from txosc import async, dispatch, osc

from time import time, sleep
import random

class gameManagement(object):
    '''Create management Dictionnary with all datas from all players'''
    def __init__(self):
        # address:   message 11 values
        # ip, socket: score1 score2 score bat0x bat0y bat1x bat1y bat2x bat2y ballx bally
        self.manage = {}
        # ('10.0.0.9', 47582): [1,2,3,4,5,6,7,8,9,10,11]
        self.master = ()
        self.numbers = []
        self.ACTA = {}

    def insert_data_in_dict(self, message, address):
        # Fill the table
        self.manage[address] = message
        #print self.manage
        # add in dict to control web
        self.ACTA[address] = time()

    def delete_disconnected_player(self):
        #print "ACTA =", self.ACTA
        for addr, t in self.ACTA.items():
            if time() -t > 0.5:
                del self.manage[addr]
                del self.ACTA[addr]
                print "Deleted in ACTA, in manage, and I kill the player: ", addr
                #print self.manage, self.ACTA

    def create_msg_for_all_players(self):
        self.msg = osc.Message("/for_all_players")
        for key, value in self.manage.items():
            self.msg.add(key[0])
            for item in value:
                self.msg.add(item)
        #print self.msg
        return self.msg

    def reset_data(self):
        self.manage = {}
        self.ACTA = {}
        print "Reset .............."

if __name__ == "__main__":
    # only to test
    # set instance of class
    game = gameManagement()

    # only to test this script
    test = [ [('10.0.0.9', 47582), [1,2,3,4,5,6,7,8,9,10,11]],
            [('10.0.0.9', 41258), [1,2,3,4,5,6,7,8,9,10,11]],
            [('10.0.0.111', 65874), [1,2,3,4,5,6,7,8,9,10,11]]  ]

    for t in test:
        game.insert_data_in_dict(t[1], t[0])
        game.create_msg_for_all_players()

    game.delete_disconnected_player()
