
#############################################################################
# Copyright (C) Labomedia May 2012
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software Foundation,
#  Inc., 51 Franproplin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
#############################################################################


import GameLogic as gl
from OSC3.OSC import OSCClient, OSCMessage

# Get controller and owner
controller = gl.getCurrentController()
owner = controller.owner
level = owner["level"]
# get all scenes
scenes = gl.getSceneList()

addr_out = gl.ip, gl.port_out
try:
    clt = OSCClient()
    clt.connect(addr_out)
except:
    pass

# Create msg with all datas in game for this player
m2 = OSCMessage("/player_data")

for scen in scenes:
    for obj in scen.objects:
        # always
        if str(obj) == "SendOSC": sendosc = obj
        # level 2
        if str(obj) == "bat20": bat20 = obj
        if str(obj) == "bat21": bat21 = obj
        if str(obj) == "goal20": goal20 = obj
        if str(obj) == "goal21": goal21 = obj
        if str(obj) == "ball2":ball2 = obj
        # level 3
        if str(obj) == "bat30": bat30 = obj
        if str(obj) == "bat31": bat31 = obj
        if str(obj) == "bat32": bat32 = obj
        if str(obj) == "goal30": goal30 = obj
        if str(obj) == "goal31": goal31 = obj
        if str(obj) == "goal32": goal32 = obj
        if str(obj) == "ball3": ball3 = obj

ball_loc = [0,0]
score = [1,2,3]
bat_loc = [1,2,3,4,5,6]

# We must (must yes) always send 11 items in data
if level == 1:
    ball_loc = [0,0]
    score = [1,2,3]
    bat_loc = [1,2,3,4,5,6]

if level == 2:
    score = [goal20["score"], goal21["score"], 3]
    bat_loc = [ bat20.localPosition[0], bat20.localPosition[1],
                bat21.localPosition[0], bat21.localPosition[1],
                1,2]
    ball_loc = [ball2.localPosition[0], ball2.localPosition[1]]

if level == 3:
    score = [goal30["score"], goal31["score"], goal32["score"]]
    bat_loc = [ bat30.localPosition[0], bat30.localPosition[1],
                bat31.localPosition[0], bat31.localPosition[1],
                bat32.localPosition[0], bat32.localPosition[1]]
    ball_loc = [ball3.localPosition[0], ball3.localPosition[1]]

m2.append(score)
m2.append(bat_loc)
m2.append(ball_loc)
#print(m2)
try:
    clt.send(m2)
except:
    pass

if sendosc["quit"]:
    m1 = OSCMessage('/quit')
    m1.append(1)
    try:
        clt.send(m1)
        print("Quit sended", m1)
    except:
        pass

if sendosc["reset"]:
    m3 = OSCMessage('/reset')
    m3.append(1)
    try:
        clt.send(m3)
        print("Reset sended", m3)
    except:
        pass

### print every 60 frames gl.tp is set in get_osc.py
##if gl.tp >58:
    ##print("/player_data", m2)
